umbrello 2.32.3 Umbrello UML Modeller is a Unified Modelling Language (UML) diagram program based on KDE Technology

Public Member Functions | Protected Member Functions | Private Attributes | List of all members
UMLOperation Class Reference

`#include <operation.h>`

Inheritance diagram for UMLOperation:

## Public Member Functions
| UMLOperation (UMLClassifier *parent, const QString &name, Uml::ID::Type id=Uml::ID::None, Uml::Visibility::Enum s=Uml::Visibility::Public, UMLObject *rt=0)
| UMLOperation (UMLClassifier *parent)
virtual | ~UMLOperation ()
bool | operator== (const UMLOperation &rhs) const
virtual void | copyInto (UMLObject *lhs) const
virtual UMLObject * | clone () const
void | setType (UMLObject *type)
void | moveParmLeft (UMLAttribute *a)
void | moveParmRight (UMLAttribute *a)
void | removeParm (UMLAttribute *a, bool emitModifiedSignal=true)
UMLAttributeList | getParmList () const
UMLAttribute * | findParm (const QString &name)
QString | toString (Uml::SignatureType::Enum sig=Uml::SignatureType::NoSig, bool withStereotype=false)
void | addParm (UMLAttribute *parameter, int position=-1)
bool | resolveRef ()
QString | getUniqueParameterName ()
virtual bool | showPropertiesDialog (QWidget *parent=0)
bool | isConstructorOperation ()
bool | isDestructorOperation ()
bool | isLifeOperation ()
void | setConst (bool b)
bool | getConst () const
void | setOverride (bool b)
bool | getOverride () const
void | setVirtual (bool b)
bool | isVirtual () const
void | setInline (bool b)
bool | isInline () const
void | setSourceCode (const QString &code)
QString | getSourceCode () const
void | saveToXMI1 (QDomDocument &qDoc, QDomElement &qElement)
Public Member Functions inherited from UMLClassifierListItem
| UMLClassifierListItem (UMLObject *parent, const QString &name, Uml::ID::Type id=Uml::ID::None)
| UMLClassifierListItem (UMLObject *parent)
virtual | ~UMLClassifierListItem ()
UMLClassifier * | getType () const
void | setTypeName (const QString &type)
virtual QString | getTypeName () const
Public Member Functions inherited from UMLObject
| UMLObject (const UMLObject &other)
| UMLObject (UMLObject *parent, const QString &name, Uml::ID::Type id=Uml::ID::None)
| UMLObject (UMLObject *parent)
| UMLObject (const QString &name=QString(), Uml::ID::Type id=Uml::ID::None)
virtual | ~UMLObject ()
bool | operator== (const UMLObject &rhs) const
virtual void | setBaseType (ObjectType ot)
ObjectType | baseType () const
QLatin1String | baseTypeStr () const
virtual void | setID (Uml::ID::Type NewID)
virtual Uml::ID::Type | id () const
QString | doc () const
bool | hasDoc () const
void | setDoc (const QString &d)
void | setVisibility (Uml::Visibility::Enum visibility)
void | setVisibilityCmd (Uml::Visibility::Enum visibility)
Uml::Visibility::Enum | visibility () const
void | setStereotype (const QString &_name)
void | setStereotypeCmd (const QString &_name)
QString | stereotype (bool includeAdornments=false) const
void | setUMLStereotype (UMLStereotype *stereo)
UMLStereotype * | umlStereotype ()
QString | package (const QString &separator=QString(), bool includeRoot=false)
UMLPackageList | packages (bool includeRoot=false) const
bool | setUMLPackage (UMLPackage *pPkg)
UMLPackage * | umlPackage () const
void | setUMLParent (UMLObject *parent)
UMLObject * | umlParent () const
virtual void | setName (const QString &strName)
virtual void | setNameCmd (const QString &strName)
QString | name () const
virtual QString | fullyQualifiedName (const QString &separator=QString(), bool includeRoot=false) const
void | setAbstract (bool bAbstract)
bool | isAbstract () const
virtual bool | loadFromXMI1 (QDomElement &element)
bool | loadStereotype (QDomElement &element)
void | setStatic (bool bStatic)
bool | isStatic () const
virtual bool | acceptAssociationType (Uml::AssociationType::Enum)
void | setSecondaryId (const QString &id)
QString | secondaryId () const
void | setSecondaryFallback (const QString &id)
QString | secondaryFallback () const
QDomElement | save1 (const QString &tag, QDomDocument &qDoc)
bool | isUMLActor ()
bool | isUMLArtifact ()
bool | isUMLAssociation ()
bool | isUMLAttribute ()
bool | isUMLCategory ()
bool | isUMLCheckConstraint ()
bool | isUMLClassifier ()
bool | isUMLComponent ()
bool | isUMLDatatype ()
bool | isUMLEntity ()
bool | isUMLEntityAttribute ()
bool | isUMLEntityConstraint ()
bool | isUMLEnum ()
bool | isUMLEnumLiteral ()
bool | isUMLFolder ()
bool | isUMLForeignKeyConstraint ()
bool | isUMLInstance ()
bool | isUMLInstanceAttribute ()
bool | isUMLNode ()
bool | isUMLObject ()
bool | isUMLOperation ()
bool | isUMLPackage ()
bool | isUMLPort ()
bool | isUMLRole ()
bool | isUMLStereotype ()
bool | isUMLTemplate ()
bool | isUMLUniqueConstraint ()
bool | isUMLUseCase ()
UMLActor * | asUMLActor ()
UMLArtifact * | asUMLArtifact ()
UMLAssociation * | asUMLAssociation ()
UMLAttribute * | asUMLAttribute ()
UMLCanvasObject * | asUMLCanvasObject ()
UMLCategory * | asUMLCategory ()
UMLCheckConstraint * | asUMLCheckConstraint ()
UMLClassifier * | asUMLClassifier ()
UMLClassifierListItem * | asUMLClassifierListItem ()
UMLClassifierSet * | asUMLClassifierSet ()
UMLComponent * | asUMLComponent ()
UMLDatatype * | asUMLDatatype ()
UMLEntity * | asUMLEntity ()
UMLEntityAttribute * | asUMLEntityAttribute ()
UMLEntityConstraint * | asUMLEntityConstraint ()
UMLEnum * | asUMLEnum ()
UMLEnumLiteral * | asUMLEnumLiteral ()
UMLFolder * | asUMLFolder ()
UMLForeignKeyConstraint * | asUMLForeignKeyConstraint ()
UMLInstance * | asUMLInstance ()
UMLInstanceAttribute * | asUMLInstanceAttribute ()
UMLNode * | asUMLNode ()
UMLObject * | asUMLObject ()
UMLOperation * | asUMLOperation ()
UMLPackage * | asUMLPackage ()
UMLPort * | asUMLPort ()
UMLRole * | asUMLRole ()
UMLStereotype * | asUMLStereotype ()
UMLTemplate * | asUMLTemplate ()
UMLUniqueConstraint * | asUMLUniqueConstraint ()
UMLUseCase * | asUMLUseCase ()

## Protected Member Functions
bool | load1 (QDomElement &element)
Protected Member Functions inherited from UMLObject
void | init ()
void | maybeSignalObjectCreated ()

## Private Attributes
Uml::ID::Type | m_returnId
| Holds the xmi.id of the <UML:Parameter kind="return"> More...
UMLAttributeList | m_List
| Parameter list. More...
bool | m_bConst
| Holds the isQuery attribute of the <UML:Operation> More...
bool | m_Override
| Holds the override attribute of the <UML:Operation> More...
bool | m_virtual
| Holds the virtual attribute of the <UML:Operation> More...
bool | m_inline
| Holds the inline attribute of the <UML:Operation> More...
QString | m_Code
| Holds the entered source code. More...

## Additional Inherited Members
Public Types inherited from UMLObject
enum | ObjectType { ot_Unknown = -1, ot_UMLObject = 100, ot_Actor, ot_UseCase, ot_Package, ot_Interface, ot_Datatype, ot_Enum, ot_Class, ot_Instance, ot_Association, ot_Attribute, ot_Operation, ot_EnumLiteral, ot_Template, ot_Component, ot_Artifact, ot_Node, ot_Stereotype, ot_Role, ot_Entity, ot_EntityAttribute, ot_Folder, ot_EntityConstraint, ot_UniqueConstraint, ot_ForeignKeyConstraint, ot_CheckConstraint, ot_Category, ot_Port, ot_InstanceAttribute, ot_SubSystem }
Public Slots inherited from UMLObject
void | emitModified ()
Signals inherited from UMLObject
void | modified ()
Static Public Member Functions inherited from UMLObject
static QString | toString (ObjectType ot)
static QString | toI18nString (ObjectType t)
static Icon_Utils::IconType | toIcon (ObjectType t)
Protected Attributes inherited from UMLObject
Uml::ID::Type | m_nId
| object's id More...
QString | m_Doc
| object's documentation More...
QPointer< UMLStereotype > | m_pStereotype
| stereotype of the object if applicable More...
QString | m_name
| objects name More...
ObjectType | m_BaseType
| objects type More...
Uml::Visibility::Enum | m_visibility
| objects visibility More...
bool | m_bAbstract
| state of whether the object is abstract or not More...
bool | m_bStatic
| flag for instance scope More...
bool | m_bInPaste
| caller sets this true when in paste operation More...
bool | m_bCreationWasSignalled
| auxiliary to maybeSignalObjectCreated() More...
QPointer< UMLObject > | m_pSecondary
QString | m_SecondaryId
QString | m_SecondaryFallback
UMLObjectPrivate * | m_d
| private data More...

## Detailed Description

This class represents an operation in the UML model.

Bugs and comments to umbre.nosp@m.llo-.nosp@m.devel.nosp@m.@kde.nosp@m..org or https://bugs.kde.org

## Constructor & Destructor Documentation

## ◆ UMLOperation() [1/2]

UMLOperation::UMLOperation | ( | UMLClassifier * | parent,
|  | const QString & | name,
|  | Uml::ID::Type | id = `Uml::ID::None`,
|  | Uml::Visibility::Enum | s = `Uml::Visibility::Public`,
|  | UMLObject * | rt = `0`
| ) |  |

Constructs a UMLOperation. Not intended for general use: The operation is not tied in with umbrello's Qt signalling for object creation. If you want to create an Operation use the method in UMLDoc instead.

Parameters

  parent | the parent to this operation
  name | the name of the operation
  id | the id of the operation
  s | the visibility of the operation
  rt | the return type of the operation

## ◆ UMLOperation() [2/2]

UMLOperation::UMLOperation | ( | UMLClassifier * | parent | ) |
| explicit

Constructs a UMLOperation. Not intended for general use: The operation is not tied in with umbrello's Qt signalling for object creation. If you want to create an Operation use the method in UMLDoc instead.

Parameters

  parent | the parent to this operation

## ◆ ~UMLOperation()

UMLOperation::~UMLOperation | ( |  | ) |
| virtual

Destructor.

## Member Function Documentation

## ◆ addParm()

void UMLOperation::addParm | ( | UMLAttribute * | parameter,
|  | int | position = `-1`
| ) |  |

Add a parameter to the operation.

Parameters

  parameter | the parameter to add
  position | the position in the parameter list. If position = -1 the parameter will be appended to the list.

## ◆ clone()

UMLObject * UMLOperation::clone | ( |  | ) | const
| virtual

Make a clone of this object.

Implements UMLClassifierListItem.

## ◆ copyInto()

void UMLOperation::copyInto | ( | UMLObject * | lhs | ) | const
| virtual

Copy the internal presentation of this object into the new object.

Reimplemented from UMLClassifierListItem.

## ◆ findParm()

UMLAttribute * UMLOperation::findParm | ( | const QString & | name | ) |

Finds a parameter of the operation.

Parameters

  name | the parameter name to search for

Returns
  the found parameter, 0 if not found

## ◆ getConst()

bool UMLOperation::getConst | ( |  | ) | const

Returns whether this operation is a query (C++ "const").

## ◆ getOverride()

bool UMLOperation::getOverride | ( |  | ) | const

Returns whether this operation has override flag.

## ◆ getParmList()

UMLAttributeList UMLOperation::getParmList | ( |  | ) | const

Returns a list of parameters.

Returns
  a list of the parameters in the operation

## ◆ getSourceCode()

QString UMLOperation::getSourceCode | ( |  | ) | const

Returns the source code for this operation.

## ◆ getUniqueParameterName()

QString UMLOperation::getUniqueParameterName | ( |  | ) |

Returns an unused parameter name for a new parameter.

## ◆ isConstructorOperation()

bool UMLOperation::isConstructorOperation | ( |  | ) |

Returns whether this operation is a constructor.

Returns
  true if this operation is a constructor

## ◆ isDestructorOperation()

bool UMLOperation::isDestructorOperation | ( |  | ) |

Returns whether this operation is a destructor.

Returns
  true if this operation is a destructor

## ◆ isInline()

bool UMLOperation::isInline | ( |  | ) | const

Returns whether this operation is inlined.

## ◆ isLifeOperation()

bool UMLOperation::isLifeOperation | ( |  | ) |

Shortcut for (isConstructorOperation() || isDestructorOperation()).

Returns
  true if this operation is a constructor or destructor

## ◆ isVirtual()

bool UMLOperation::isVirtual | ( |  | ) | const

Returns whether this operation is a virtual method.

## ◆ load1()

bool UMLOperation::load1 | ( | QDomElement & | element | ) |
| protected virtual

Loads a <UML:Operation> XMI element.

Reimplemented from UMLObject.

## ◆ moveParmLeft()

void UMLOperation::moveParmLeft | ( | UMLAttribute * | a | ) |

Move a parameter one position to the left.

Parameters

  a | the parameter to move

## ◆ moveParmRight()

void UMLOperation::moveParmRight | ( | UMLAttribute * | a | ) |

Move a parameter one position to the right.

Parameters

  a | the parameter to move

## ◆ operator==()

bool UMLOperation::operator== | ( | const UMLOperation & | rhs | ) | const

Overloaded '==' operator.

## ◆ removeParm()

void UMLOperation::removeParm | ( | UMLAttribute * | a,
|  | bool | emitModifiedSignal = `true`
| ) |  |

Remove a parameter from the operation.

Parameters

  a | the parameter to remove
  emitModifiedSignal | whether to emit the "modified" signal which creates an entry in the Undo stack for the removal, default: true

## ◆ resolveRef()

bool UMLOperation::resolveRef | ( |  | ) |
| virtual

Calls resolveRef() on all parameters. Needs to be called after all UML objects are loaded from file.

Returns
  true for success

Reimplemented from UMLObject.

## ◆ saveToXMI1()

void UMLOperation::saveToXMI1 | ( | QDomDocument & | qDoc,
|  | QDomElement & | qElement
| ) |  |
| virtual

Saves to the <UML:Operation> XMI element.

Reimplemented from UMLObject.

## ◆ setConst()

void UMLOperation::setConst | ( | bool | b | ) |

Sets whether this operation is a query (C++ "const").

## ◆ setInline()

void UMLOperation::setInline | ( | bool | b | ) |

Sets whether this operation is inlined.

## ◆ setOverride()

void UMLOperation::setOverride | ( | bool | b | ) |

Sets whether this operation has override flag.

## ◆ setSourceCode()

void UMLOperation::setSourceCode | ( | const QString & | code | ) |

Sets the source code for this operation.

Parameters

  code | the body of this operation

## ◆ setType()

void UMLOperation::setType | ( | UMLObject * | type | ) |
| virtual

Reimplement method from UMLClassifierListItem.

Parameters

  type | pointer to the type object

Reimplemented from UMLClassifierListItem.

## ◆ setVirtual()

void UMLOperation::setVirtual | ( | bool | b | ) |

Sets whether this operation is a virtual method.

## ◆ showPropertiesDialog()

bool UMLOperation::showPropertiesDialog | ( | QWidget * | parent = `0` | ) |
| virtual

Display the properties configuration dialog for the template.

Parameters

  parent | the parent for the dialog

Reimplemented from UMLObject.

## ◆ toString()

QString UMLOperation::toString | ( | Uml::SignatureType::Enum | sig = `Uml::SignatureType::NoSig`,
|  | bool | withStereotype = `false`
| ) |  |
| virtual

Returns a string representation of the operation.

Parameters

  sig | what type of operation string to show

Returns
  the string representation of the operation

Reimplemented from UMLClassifierListItem.

## Member Data Documentation

## ◆ m_bConst

bool UMLOperation::m_bConst
| private

Holds the isQuery attribute of the <UML:Operation>

## ◆ m_Code

QString UMLOperation::m_Code
| private

Holds the entered source code.

## ◆ m_inline

bool UMLOperation::m_inline
| private

Holds the inline attribute of the <UML:Operation>

## ◆ m_List

UMLAttributeList UMLOperation::m_List
| private

Parameter list.

## ◆ m_Override

bool UMLOperation::m_Override
| private

Holds the override attribute of the <UML:Operation>

## ◆ m_returnId

Uml::ID::Type UMLOperation::m_returnId
| private

Holds the xmi.id of the <UML:Parameter kind="return">

## ◆ m_virtual

bool UMLOperation::m_virtual
| private

Holds the virtual attribute of the <UML:Operation>

The documentation for this class was generated from the following files:

- umbrello/uml1model/operation.h
- umbrello/uml1model/operation.cpp